#/bin/bash

# Script for forms definitions exports/imports in QVANTUM, based on curl and jq.
# This script is strongly simplified, as it completely omits error processing.

# Endpoints for QVANTUM tenants
AUTH=https://auth.qvantum-plan.de
API=https://api.qvantum-plan.de

# TODO: fill in your tenant information
#TENANT=
#CLIENTID=
#USERNAME=
#PASSWORD=

# Authentication
TOKEN=$(curl -s -X POST \
   -H "Content-Type:application/x-www-form-urlencoded" \
   -d "grant_type=password" \
   -d "client_id=${CLIENTID}" \
   -d "username=${USERNAME}" \
   -d "password=${PASSWORD}" \
   "${AUTH}/auth/realms/${TENANT}/protocol/openid-connect/token" | jq -r .access_token)

# Navigation to tenant and planning application
PLANNING_APP_URL=$(curl -s -X GET \
   -H "Authorization:Bearer ${TOKEN}" \
   "${API}/api/v1/tenants" | jq -r .tenants[0]._links.planningApplications[0].href)

# Navigation to cube
CUBES_URL=$(curl -s -X GET \
   -H "Authorization:Bearer ${TOKEN}" \
   "${PLANNING_APP_URL}" | jq -r ._links.allCubes.href)

CUBE_URL=$(curl -s -X GET \
   -H "Authorization:Bearer ${TOKEN}" \
   "${CUBES_URL}" | jq -r .cubes[0]._links.self.href)

FORMS_IMPORT_URL=$(curl -s -X GET \
   -H "Authorization:Bearer ${TOKEN}" \
   "${CUBE_URL}" | jq -r ._links.allExternalForms.href)

echo "Importing forms definition..."

curl -s -X PUT \
  -H "Authorization:Bearer ${TOKEN}" \
  -H "Content-Type:application/x.de.qvantum-plan.external-forms+json" \
  -d @../json/forms-pretty.json \
  "${FORMS_IMPORT_URL}"

echo "Exporting current forms definition..."

curl -s -X GET \
  -H "Authorization:Bearer ${TOKEN}" \
  -H "Accept:application/x.de.qvantum-plan.external-forms+json" \
  "${FORMS_IMPORT_URL}" | jq -r .
