#/bin/bash

# Script for permission assignment upload and retrieval in QVANTUM, based on curl and jq.
# This script is strongly simplified, as it completely omits error processing.

# Endpoints for QVANTUM tenants
AUTH=https://auth.qvantum-plan.de
API=https://api.qvantum-plan.de

# TODO: fill in your tenant information
#TENANT=
#CLIENTID=
#USERNAME=
#PASSWORD=

# Authentication
TOKEN=$(curl -s -X POST \
   -H "Content-Type:application/x-www-form-urlencoded" \
   -d "grant_type=password" \
   -d "client_id=${CLIENTID}" \
   -d "username=${USERNAME}" \
   -d "password=${PASSWORD}" \
   "${AUTH}/auth/realms/${TENANT}/protocol/openid-connect/token" | jq -r .access_token)

# Navigation to tenant and planning application
PLANNING_APP_URL=$(curl -s -X GET \
   -H "Authorization:Bearer ${TOKEN}" \
  "${API}/api/v1/tenants" | jq -r .tenants[0]._links.planningApplications[0].href)

PERMISSION_DEFINITION_PATH=$(pwd)/../csv/metadata/team/permissions.csv

PERMISSIONS_URL=$(curl -s -X GET \
 -H "Authorization:Bearer ${TOKEN}" \
"${PLANNING_APP_URL}" | jq -r ._links.allPermissions.href);

cat $PERMISSION_DEFINITION_PATH;

curl -s -X PUT \
  -H "Authorization:Bearer ${TOKEN}" \
  -H "Content-Type:text/csv" \
  --data-binary @$PERMISSION_DEFINITION_PATH \
"${PERMISSIONS_URL}"

# Retrieve permission assignment
curl -s -X GET \
  -H "Authorization:Bearer ${TOKEN}" \
  -H "Content-Type:text/csv" \
  "${PERMISSIONS_URL}"
